
/* cnode.h -- definitions for kernel-internal cnode struct,
   used to keep track of inodes on the Coda filesystem

  Copyright 1997-98 Michael Callahan
  Copyright 1999 Carnegie Mellon University
  This program is free software.  You may copy it according
  to the conditions of the GNU General Public License version 2.0
  or later; see the file COPYING in the source directory.
*/

#ifndef	_CNODE_H_
#define	_CNODE_H_

#ifndef MAKE_CSTR
#define MAKE_CSTR(_str, _name, _hash)	(char *)_str.name = _name;\
										_str.len = strlen(_name);\
										_str.hash = _hash;
#endif


struct cnode {
	u_short				c_flags;							/* flags (see cache.h) */
	ViceFid				c_fid;	    						/* file handle */
	struct dentry		*c_dentry;
	void				*c_search;
	u_short				c_ocount;   						/* count of openers */
	struct coda_vattr  	c_vattr;							/* attributes */
	char				*c_container;
	dllist_chain		c_cf;							/* fid cache */
};




#endif	

