
#include "MC.h"

#pragma VxD_LOCKED_DATA_SEG
#pragma VxD_LOCKED_CODE_SEG

/*
 * Insert a new entry after the specified head..
 */
void list_add(struct dllist_head *entry, struct dllist_head *head)
{
	head->next->prev = entry;
	entry->next = head->next;
	entry->prev = head;
	head->next = entry;
}

/*
 * Delete a list entry by making the prev/next entries
 * point to each other.
 */


void list_del (struct dllist_head *le)
{

	le->prev->next = le->next;
	le->next->prev = le->prev;
}

void list_init(struct dllist_head *lh)
{
	lh->prev = lh;
	lh->next = lh;
}

int list_empty(struct dllist_head *lh)
{
	return (lh->next == lh);

}
