/* init.c -- initialization code
   Copyright 1997-98 Michael Callahan
   Copyright 1999 Carnegie Mellon University
   This program is free software.  You may copy it according
   to the conditions of the GNU General Public License version 2.0
   or later; see the file COPYING in the source directory.
*/


#include <string.h>
#pragma intrinsic (memset, strcpy)

#include "MC.h"

#pragma VxD_LOCKED_DATA_SEG
#pragma VxD_LOCKED_CODE_SEG

static char copyright[] = "Copyright 1997 Michael Callahan\n";

#pragma warning(default: 4035)

/* symbols defined in MCvxd.asm */
extern DWORD BSSstart, BSSend;

void OnTimeoutEvent();

DWORD dwTimeoutEventHdl = 0;
DWORD Debuglevel;

BOOL OnDeviceInit ()
{
	HKEY	hkey;
	char	regpath[256];
	DWORD	dl;
	DWORD	cbdata = sizeof(Debuglevel);

	/* clear bss segment */
	memset (&BSSstart, 0, ((char *)&BSSend) - ((char *)&BSSstart));

	dl = 100;

	strcpy(regpath, "System\\CurrentControlSet\\Services\\VxD\\Codadev");
	_RegOpenKey(HKEY_LOCAL_MACHINE, regpath, &hkey);
	_RegQueryValueEx(hkey, "Debuglevel", NULL, NULL, (PBYTE) &dl, &cbdata);
	_RegCloseKey(hkey);

	printf("Setting debug level %x", dl);
	Debuglevel = dl;

	/* set timeout event for 4 seconds (=4000msec) from now */
	dwTimeoutEventHdl = Set_Global_Time_Out (OnTimeoutEvent,
		4000, 0);
	if (!dwTimeoutEventHdl)
		return FALSE;

	init_cache();

	return TRUE;
}

void OnTimeoutEvent ()
{
	calls[0]++;
	heartbeat();
	dwTimeoutEventHdl = Set_Global_Time_Out (OnTimeoutEvent,
		8000, 0);
}


int inUseCount = 0;

BOOL OnDeviceExit ()
{
	d_shrink_cache();
	Cancel_Time_Out(dwTimeoutEventHdl);
	return TRUE;
}
