/*
  Copyright 1997-98 Michael Callahan
  Copyright 1999 Carnegie Mellon University
  This program is free software.  You may copy it according
  to the conditions of the GNU General Public License version 2.0
  or later; see the file COPYING in the source directory.
*/
#define KERNEL 1

#pragma pack(push, 4)

#include "coda.h"

struct req_list_entry {
	struct req_list_entry	*next;
	struct req_list_entry	*prev;
};

#define REQUEST_SIZE (sizeof(struct request))
#define USER_LEVEL_REQUEST_SIZE (REQUEST_SIZE  \
  - sizeof (struct req_list_entry) - 2*sizeof (DWORD) - 2*sizeof (int))


struct request {
	struct req_list_entry		le;			/* list threading pointers */
	int							doneflag;	/* flag for testing when done */
	DWORD						length;		/* length of request from "r" union on */
	DWORD						rh;			/* resource handle of this connection */
	int							age;		/* age of request -- used for timing out */
	union {
		union inputArgs		in;
		union outputArgs		out;
	} r;
	/* more data may go here */
};

#pragma pack(pop)
