#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <windows.h>

HANDLE hdl;
int lock;

void load(char *file)
{
	int res = 0;
	if (lock) return;
	hdl = CreateFile(file, 0, 0, NULL, 0, FILE_FLAG_DELETE_ON_CLOSE, NULL);
	if (hdl == INVALID_HANDLE_VALUE) {
		res = GetLastError();
		printf ("\ncreate handle error %d\n", res);
		exit (-1);
	}
	printf ("\ncreate handle error %d\n", res);
	lock = 1;
}


void unload(char *file)
{	
	int res =0;
	if (!lock) return;
	if (!CloseHandle(hdl)){
		res = GetLastError();
	}
	printf ("\nclose handle error %d\n", res);
	DeleteFile(file);
	lock = 0;
}

void main(int ac, char **av)
{
	int ch;
	lock = 0;
	char prefix[7] = "\\\\.\\";
	char VXDName[16];
	char VXDFName[19];
	char *tail = strrchr(av[1], '.');;

	if(ac!=2 || !tail) {
	    fprintf(stderr,"usage: loadvxd <vxdfilename.vxd>\n");
		return;
    }

	strcpy(VXDName, prefix); memcpy(VXDName+4, av[1], tail-av[1]);
	strcpy(VXDFName, prefix); strcat(VXDFName, av[1]);

	while (1){
		printf ("\n1 .......... load\n");
		printf ("2 .......... unload\n");
		printf ("e .......... exit\n");
		printf ("choice :");
		ch = _getch();
		ch = toupper(ch);
		if (ch == 'E') {
			CloseHandle(hdl);
			DeleteFile(VXDName);
			exit (0);
		}
		if (ch == '1') load(VXDFName);
		if (ch == '2') unload(VXDName);
	}
}