/* mc.h -- minicache headers
  Copyright 1997-98 Michael Callahan
  Copyright 1999 Carnegie Mellon University
  This program is free software.  You may copy it according
  to the conditions of the GNU General Public License version 2.0
  or later; see the file COPYING in the source directory.
*/


#define WANTVXDWRAPS
#include <basedef.h>
#include <vmm.h>
#include <ios.h>
#include <ifs.h>
#include <vwin32.h>
#include <regdef.h>
#include <vxdwraps.h>

#include "dcache.h"

#include "vdcache.h"


#include <winerror.h>

#include "ifsmgr.h"
#include "iosdcls.h"


#include "dllist.h"


#pragma warning(disable: 4102)

/* devio.c */

DWORD OnW32DeviceIoControl(HVM, PDIOCPARAMETERS);

/* file.c */
int OpenFile (pioreq pir);
int FileSeek (pioreq pir);
int CloseFile (pioreq pir);
int CommitFile (pioreq pir);
int LockFile (pioreq pir);
int FileDateTime (pioreq pir);
int NamedPipeRequest (pioreq pir);
int NamedPipeHandleInfo (pioreq pir);
int EnumerateHandle (pioreq pir);


/* find.c */
int SearchFile (pioreq pir);
int FindFirstFile (pioreq pir);
int EnumerateFind (pioreq pir);
int FindFileClose (pioreq pir);
int ErrorStub (pioreq pir);

/* vol.c */

USHORT	coda_volume_name[]; 
int ConnectNetResource (pioreq pir);
int DisconnectResource (pioreq pir);
int DeleteFile (pioreq pir);
int FileAttributes (pioreq pir);
int FlushVolume (pioreq pir);
int Dir (pioreq pir);
int GetDiskInfo (pioreq pir);
int QueryResourceInfo (pioreq pir);
int RenameFile (pioreq pir);
int UNCNamedPipeRequest (pioreq pir);
int Ioctl16Drive (pioreq pir);
int GetDiskParams (pioreq pir);
int DirectDiskIO (pioreq pir);


extern UINT uiNetId;
extern UINT uiProviderId;

/* hook.c */
extern dllist_chain hooks;
extern ppIFSFileHookFunc    orig;
extern ppIFSFileHookFunc    init;
int call_orig(pIFSFunc pfn, int fn, int Drive, int ResType,int CodePage, pioreq pir, 
			  struct dentries *des);
int _cdecl VdcacheHookProc(pIFSFunc pfn, int fn, int Drive, int ResType,
                           int CodePage, pioreq pir);
/* init.c */

extern int inUseCount;
BOOL OnDeviceInit();
extern DWORD Debuglevel;

extern dllist_chain filesystems;


struct filesystem *findFS(char *letter);
int checkFS(struct filesystem *_fs);
int checkHS(struct filesystem *_fs);

int VXDINLINE CHECKFS(struct filesystem *fs)
{
	if (!fs || !checkFS(fs)) 
		return ERROR_INVALID_PARAMETER;
	else return 0;
}


/* namei.c */

int namei(pFilesystem fs, char *upp, struct dentry **de, int flags);