#ifndef	_CACHE_H_
#define	_CACHE_H_

#include "misc.h"
#include "dllist.h"


//#define HASHBITS 10
#define HASHSIZE 509  /* prime number close to 1024 */
//#define HASHMASK HASHSIZE -1 
	
#define INIT_HASH 0
#define IS_NEGATIVE(de)	(((de)->d_neg) == 1)

#define CASE_SENSITIVE 1
#define CASE_INSENSITIVE 2

void d_init();
struct dentry *dget (struct dentry *de);
void dput(struct dentry *de);
struct dllist_head *d_hash(struct dentry *parent, unsigned int hash);
void d_drop(struct dentry *de);
struct dentry *d_alloc(struct filesystem *fs, struct cstr *name, struct dentry *parent);
int d_lookup(struct filesystem *fs, char *path, struct dentry *startde, struct dentry **de, int flags);
void d_switchhash(struct dentry *de1, struct dentry *de2);
void d_rehash(struct dentry *de1);
struct dentry *d_getnextchild(struct dentry *dirde, struct dllist_head *);
void d_shrink_cache();
void d_prune_one_dentry(struct dentry *de);
void d_prune_cache(int count);
void d_shrink_cache_parent(struct dentry *parent);
int d_select_parent(struct dentry *parent);
void d_instantiate(struct dentry *, DWORD);
void d_free_all();


#endif