

#include "cache.h"

#include <string.h>
#pragma intrinsic(strlen, strcpy, memset, memcpy, strcmp, memcmp)

#include "vmmextra.h"

#pragma VxD_LOCKED_DATA_SEG
#pragma VxD_LOCKED_CODE_SEG

DWORD DevIo_Status (PDIOCPARAMETERS);

void PM_API (HVM, DWORD, PCRS);

void __declspec(naked) VDCACHE_PM_API ()
{
	_asm {
		push	ebp
		push	edi
		push	ebx
		call	PM_API
		pop		eax
		pop		eax
		pop		eax
		ret
	}
}

void PM_API (HVM hVM, DWORD hThread, PCRS pRegs)
{
	DIOCPARAMETERS params;

	params.VMHandle = (DWORD) hVM;
	params.dwIoControlCode = pRegs->Client_EAX;
	params.lpvInBuffer = Client_Ptr_Flat(CLIENT_DS, CLIENT_SI);
	params.cbInBuffer = pRegs->Client_EBX;
	params.lpvOutBuffer = Client_Ptr_Flat(CLIENT_DS, CLIENT_DI);
	params.cbOutBuffer = pRegs->Client_ECX;
	params.lpcbBytesReturned = (DWORD) &pRegs->Client_ECX;
	params.lpoOverlapped = 0;
	params.hDevice = 0;
	params.tagProcess = 0;

	pRegs->Client_EAX = OnW32DeviceIoControl (hVM, &params);
	if (pRegs->Client_EAX)
		pRegs->Client_EFlags |= CF_MASK;
	else
		pRegs->Client_EFlags &= ~CF_MASK;
}

DWORD OnW32DeviceIoControl (HVM hVM, PDIOCPARAMETERS p)
{
	switch (p->dwIoControlCode) {
	case DIOC_GETVERSION:
		return 0;

	case 1:
		return DevIo_Status(p);

	}

	return ERROR_INVALID_PARAMETER;
}


DWORD DevIo_Status (PDIOCPARAMETERS p)
{
	PDWORD pOut;

	if (!p->lpvOutBuffer || p->cbOutBuffer < 10 * sizeof(DWORD))
		return ERROR_INVALID_PARAMETER;

	pOut = (PDWORD) p->lpvOutBuffer;

	pOut[0] = uiNetId;
	pOut[1] = uiProviderId;

	return 0;
}
