/* 
	hook.c -- hook routines for VDCACHE 
    Copyright 1999 Marc Schnieder
*/

#include "cache.h"
#include <string.h>
#pragma intrinsic(strcpy, strlen, memcpy)

#pragma VxD_LOCKED_DATA_SEG
#pragma VxD_LOCKED_CODE_SEG

dllist_chain hooks;
ppIFSFileHookFunc       orig = NULL;
ppIFSFileHookFunc       init = NULL;

int call_orig(pIFSFunc pfn, int fn, int Drive, int ResType, 
							int CodePage, pioreq pir, 
							struct dentries *des){
	return (*orig)(pfn, fn, Drive, ResType, CodePage, pir);
}

#pragma optimize("", off)
int _cdecl VdcacheHookProc(pIFSFunc pfn, int fn, int Drive, int ResType,
                           int CodePage, pioreq pir)
{
	pFilesystem fs = NULL;
	struct dllist_head *le = NULL;
	struct dentries *des = NULL;

    //
    // Now extract parameters based on the function type.
    //
    switch( fn ) {

    case IFSFN_OPEN:
        break;

    case IFSFN_READ:
		break;

    case IFSFN_WRITE:
        break;

    case IFSFN_CLOSE:
        break;

    case IFSFN_DIR:
        break;

    case IFSFN_SEEK:
        break;

    case IFSFN_COMMIT:
        break;

    case IFSFN_FILELOCKS:
        break;

    case IFSFN_FINDOPEN:
        break;

    case IFSFN_FINDNEXT:
        break;

    case IFSFN_FINDCLOSE:
        break;

    case IFSFN_FILEATTRIB:
        break;

    case IFSFN_FILETIMES:
        break;

    case IFSFN_FLUSH:
        break;

    case IFSFN_DELETE:
        break;

    case IFSFN_SEARCH:
        break;
    
    case IFSFN_GETDISKINFO:
        break;

    case IFSFN_RENAME:
        break;

    case IFSFN_IOCTL16DRIVE:
        break;

    }

	le = hooks.next;
	if (le == &hooks) return (*init)(pfn, fn, Drive, ResType, CodePage, pir);

	fs = list_entry(le, struct filesystem, f_list);
	if (!fs) return (*init)(pfn, fn, Drive, ResType, CodePage, pir);

	if (fs->f_letter != '\0')
		if (fs->f_letter - '@' == Drive)
			return (*fs->f_type.fst_hook_func)(pfn, fn, Drive, ResType, CodePage, pir, des);

	return (*init)(pfn, fn, Drive, ResType, CodePage, pir);
}
#pragma optimize("", on)