/* 
	namei.c -- namei routines for VDCACHE 
    Copyright 1999 Marc Schnieder
*/

#include "cache.h"
#include <string.h>
#pragma intrinsic(strcpy, strlen, memcpy)

#pragma VxD_LOCKED_DATA_SEG
#pragma VxD_LOCKED_CODE_SEG

int namei(pFilesystem fs, char *upp, struct dentry **de, int flags){

	int res = 0;
	LOGDEBUG("--namei--", 1);

	if (!fs->f_root)
		return ERROR_INVALID_PARAMETER;

	if (!upp){
		LOGDEBUG("--namei root--", 10);
		*de = dget(fs->f_root);
		return 0;
	}

	res = d_lookup(fs, upp, NULL, de, flags); 

	LOGDEBUG("--end of namei--", 1);

	return res;
}

