	name VDCACHE
	.386p
	include vmm.inc
	include ilb.inc
	include drp.inc
	include vwin32.inc

VxD_IDATA_SEG

; VDCACHE_ILB -- IOS Linkage Block (IOS=I/O Supervisor)
; Gets stuffed with pointers to I/O Supervisor functions when we call
;    IOS_Register()
; However, we have no use for these, so we put this in the
; initialization segment where it will be thrown away.

VDCACHE_ILB	ILB		<>

VxD_IDATA_ENDS

VxD_LOCKED_DATA_SEG

; VDCACHE_DRP -- Device Registration Packet for IOS
; The C-language OnDeviceInit() routine needs to pass a pointer to this
; to IOS_Register(), so we make this a C-visible name
public _VDCACHE_DRP

_VDCACHE_DRP	DRP		<EyeCatcher,	\   ; Eyecatcher string for mem dumps
					DRP_TSD,		\	; IOS stack position
					0,				\   ; addr of async event routine
					offset32 VDCACHE_ILB,\	; addr of ILB
					'VDCACHE         '> ; 16-char driver name

VxD_LOCKED_DATA_ENDS


; VDCACHEVxD_DDB -- device header, exported to the VxD loader by being
; mentioned in the .MAP file

	EXTRN	_VDCACHE_PM_API:NEAR

VDCACHE_Device_Id equ 01232h
Create_VDCACHE_Service_Table   equ   1

Begin_Service_Table VDCACHE
    VDCACHE_Service     VDCACHE_Get_Version, LOCAL
;    VDCACHE_Service     _VDCACHE_Attach_FS
    VDCACHE_Service     _register_filesystem
    VDCACHE_Service     _unregister_filesystem
;    VDCACHE_Service     _VDCACHE_Detach_FS
    VDCACHE_Service     _VDCACHE_New_FS
    VDCACHE_Service     _VDCACHE_Del_FS
    VDCACHE_Service     _dget
    VDCACHE_Service     _dput
    VDCACHE_Service     _d_drop
    VDCACHE_Service     _d_lookup
    VDCACHE_Service     _d_switchhash
    VDCACHE_Service     _d_getnextchild
    VDCACHE_Service     _d_shrink_cache
    VDCACHE_Service     _d_prune_one_dentry
    VDCACHE_Service     _d_prune_cache
    VDCACHE_Service     _d_shrink_cache_parent
    VDCACHE_Service     _d_instantiate
    VDCACHE_Service     _d_rehash
    VDCACHE_Service     _d_alloc_root
End_Service_Table VDCACHE

Declare_Virtual_Device VDCACHE,	\	; VxD name
	1, 0,						\	; major, minor version
	VDCACHE_Control,			\	; control dispatch routine
	VDCACHE_DEVICE_ID,		\	; undefined device ID
	<FSD_Init_Order+7fh>,		\	; initialiation order
	 , _VDCACHE_PM_API,			\	; V86, PM APIs
	_VDCACHE_DRP

VxD_LOCKED_CODE_SEG

; VDCACHE_Control -- routine dispatches VxD messages from VMM

Begin_Control_Dispatch VDCACHE

Control_Dispatch Device_Init, _OnDeviceInit, cCall, <>
;Control_Dispatch Sys_Dynamic_Device_Init, _OnDeviceInit, cCall, <>
;Control_Dispatch Sys_Dynamic_Device_Exit, _OnDeviceExit, cCall, <>
Control_Dispatch W32_DeviceIoControl, _OnW32DeviceIoControl, cCall, <ebx, esi>

End_Control_Dispatch VDCACHE

BeginProc VDCACHE_Get_Version
			mov		eax, 10h
			clc
			ret
EndProc VDCACHE_Get_Version


VxD_LOCKED_CODE_ENDS

; following two segments are placed before
; and after .bss (see .def file) -- C code
; will clear the bss during OnDeviceInit

_BSS_START	segment	dword flat 'lcode'
			public _BSSstart
_BSSstart	dd	0
_BSS_START	ends

_BSS_END	segment dword flat 'lcode'
			public _BSSend
_BSSend	dd	0
_BSS_END	ends

	end


