// CodaStartDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CodaLSock.h"
#include "CodaMsgList.h"
#include "CodaconMsgList.h"
#include "ProcWatch.h"
#include "CodaStart.h"
#include "CodaStartDlg.h"
#include "ConfDlg.h"

#define KERNEL
#include "coda.h"
 
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodaStartDlg dialog

CCodaStartDlg::CCodaStartDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCodaStartDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCodaStartDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pCodaMsgList = new CCodaMsgList;
	m_pCodaconMsgList = new CCodaconMsgList;
}

void CCodaStartDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCodaStartDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCodaStartDlg, CDialog)
	//{{AFX_MSG_MAP(CCodaStartDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_LISTEN, OnListenBtn)
	ON_BN_CLICKED(IDC_PIPETEST, OnPipetest)
	ON_BN_CLICKED(IDC_STARTVENUS, OnStartVenus)
	ON_BN_CLICKED(IDC_STARTRELAY, OnStartRelay)
	ON_BN_CLICKED(IDC_INIT, OnInitBtn)
	ON_BN_CLICKED(IDC_MOUNT_UNMOUNT, OnMountUnmount)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, OnSelchangeTab)
	ON_BN_CLICKED(IDC_MORELESS, OnMoreless)
	ON_BN_CLICKED(IDC_CONF, OnConf)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodaStartDlg message handlers

BOOL CCodaStartDlg::OnInitDialog()
{
	TC_ITEM tc_i;
	WINDOWPLACEMENT lpwndpl; 
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_pCodaconMsgList->ShowWindow(SW_HIDE);			
	m_pCodaMsgList->ShowWindow(SW_SHOW);	

	// Listen checkbutton initialization
	m_pListenBtn = (CButton*) GetDlgItem (IDC_LISTEN);
	m_pListenBtn->SetCheck (BST_CHECKED);
	m_pCodaMsgList->SetListen(TRUE);

	// Codaconn init
	m_pCodaconMsgList->SetListen(TRUE);
	m_pCodaconMsgList->Attach((CListCtrl*) GetDlgItem (IDC_CODACONMSG), 2430);

	// Init checkbutton initialization
	m_pInitBtn = (CButton*) GetDlgItem (IDC_INIT);
	m_pInitBtn->SetCheck (BST_UNCHECKED);
	m_bInit = FALSE;

	// Get Reset button
	m_pResetBtn = (CButton*) GetDlgItem (IDC_RESET);

	// Listbox initialization
	m_pCodaMsgList->Attach((CListCtrl*) GetDlgItem (IDC_CODAMSG));

	// Init Tab
	m_pTab = (CTabCtrl *) GetDlgItem(IDC_TAB);
	tc_i.mask = TCIF_TEXT;
	tc_i.iImage = -1;
	tc_i.lParam = NULL;
	tc_i.pszText = "Venus/Kernel messages";
	tc_i.cchTextMax = strlen(tc_i.pszText);
	m_pTab->InsertItem(0, &tc_i);
	tc_i.pszText = "Codacon";
	tc_i.cchTextMax = strlen(tc_i.pszText);
	m_pTab->InsertItem(1, &tc_i);

	// Init extension
	m_bExtension = FALSE;
	GetWindowPlacement(&lpwndpl);
	lpwndpl.rcNormalPosition.bottom -= 285;
	SetWindowPlacement(&lpwndpl);

	m_ccommandline = (char*) malloc (200);
	*m_ccommandline = '\0';

	// Status initialization

	m_pProcWatch = new CProcessWatcher(_TEXT("venus"), this, IDC_VENUSSTATUS);
	m_pProcWatch2 = new CProcessWatcher(_TEXT("relay"), this, IDC_RELAYSTATUS);
	m_pThread = AfxBeginThread (CCodaStartDlg::Watcher, this);

	SetMounted(-1);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCodaStartDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCodaStartDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCodaStartDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CCodaStartDlg::OnReset() 
{
	m_pCodaMsgList->Reset();
}

void CCodaStartDlg::OnListenBtn() 
{
	m_pCodaMsgList->SetListen((m_pListenBtn->GetCheck() == BST_CHECKED) ? TRUE : FALSE);
}

UINT CCodaStartDlg::Watcher(LPVOID pParam)
{
	CCodaStartDlg* p = (CCodaStartDlg*) pParam;

	while (1) {
		p->m_pProcWatch->Update();
		p->m_pProcWatch2->Update();
		::Sleep(2000);
	}
	return 0;
}

void CCodaStartDlg::OnPipetest() 
{
	HANDLE hdl;

	struct PioctlData data;
	
	CHAR buf[200];
	DWORD dwNumout;
	struct VolumeStatus {
		DWORD Vid;
		DWORD ParentId;
		UCHAR Online;
		UCHAR InService;
		UCHAR Blessed;
		UCHAR NeedsSalvage;
		DWORD Type;
		DWORD MinQuota;
		DWORD MaxQuota;
		DWORD BlocksInUse;
		DWORD PartBlocksAvail;
		DWORD PartMaxBlocks;
	} *vstat;                       

	hdl = CreateFile("\\\\.\\CODADEV", 0, 0, NULL, OPEN_EXISTING, FILE_FLAG_DELETE_ON_CLOSE, NULL);
	if (hdl == INVALID_HANDLE_VALUE) {
		AfxMessageBox(IDP_CREATEFILEFAILED);
		return;
	}

	unsigned long cmd = (4 & ~(PIOCPARM_MASK << 16)); /* mask out size  */
    int	size = ((4 >> 16) & PIOCPARM_MASK) + sizeof(char *) + sizeof(int);
    cmd	|= (size & PIOCPARM_MASK) << 16;  /* or in corrected size */

	char *dir="dir";
	data.path=dir;

//	data.cmd = cmd;
    data.follow = 0;
    data.vi.in = &buf[0];
	data.vi.in_size = 10;
	data.vi.out = &buf[0];
	data.vi.out_size = 200;

	memset(buf, 0, sizeof(buf));

	if (!DeviceIoControl (hdl, 11, (LPVOID)&data, sizeof(struct PioctlData), data.vi.out, 200, &dwNumout, NULL))
		AfxMessageBox(IDP_TRANSACTFAILED);

	vstat = (struct VolumeStatus *) buf;

	CString str;
	str.Format(_TEXT("%x %d %d %d %d  %d %d %d %d %s"),
				vstat->Vid,
				vstat->Online,
				vstat->InService,
				vstat->Blessed,
				vstat->NeedsSalvage,
				vstat->Type,
				vstat->MinQuota,
				vstat->MaxQuota,
				vstat->BlocksInUse,
				(PCHAR) (vstat + 1)); 

	PCHAR pp = (PCHAR) (vstat + 1);
	pp += strlen(pp) + 1;
	str += pp;
	pp += strlen(pp) + 1;
	str += pp;

/*	CString str2;
	for (int j = 0; j < 10; j++) {
		str2.Format ("%02x", buf[j]);
		str += str2;
	} */
	SetDlgItemText (IDC_PIPERES, str);

	CloseHandle(hdl);
}

void CCodaStartDlg::OnStartVenus() 
{
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	char target[50];

	memset (&si, 0, sizeof(si));
	si.cb = sizeof(si);
	si.dwFlags = STARTF_USESHOWWINDOW;
	// si.wShowWindow = SW_HIDE;
	si.wShowWindow = SW_SHOWMINNOACTIVE;

	if (m_bInit){
		if (AfxMessageBox(IDP_CONFIRMINIT, MB_OKCANCEL)==IDOK){
			strcpy(target, "c:\\usr\\coda\\bin\\venus.exe -init -cf 1500 ");
		}
	} else strcpy(target, "c:\\usr\\coda\\bin\\venus.exe ");

	strcat(target, m_ccommandline);

	if (CreateProcess (NULL, target,
			NULL, NULL, FALSE, 0, NULL, "c:\\usr\\coda\\bin", &si, &pi)) {
		CloseHandle (pi.hProcess);
		CloseHandle (pi.hThread);
	}
}

void CCodaStartDlg::OnStartRelay() 
{
	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	memset (&si, 0, sizeof(si));
	si.cb = sizeof(si);
	si.dwFlags = STARTF_USESHOWWINDOW;
	// si.wShowWindow = SW_HIDE;
	si.wShowWindow = SW_SHOWMINNOACTIVE;

	if (CreateProcess (NULL, "c:\\usr\\coda\\bin\\relay.exe",
			NULL, NULL, FALSE, 0, NULL, "c:\\usr\\coda\\bin", &si, &pi)) {
		CloseHandle (pi.hProcess);
		CloseHandle (pi.hThread);
		SetMounted(0);
	} 

}

void CCodaStartDlg::SetInit (BOOL b)
{
	m_bInit = b;
}

void CCodaStartDlg::SetMounted (int b)
{
	if (b==1){
		this->SetDlgItemText(IDC_MOUNTED, _TEXT("Mounted"));
		this->SetDlgItemText(IDC_MOUNT_UNMOUNT, _TEXT("Unmount"));
	}
	else if (b==0){
		this->SetDlgItemText(IDC_MOUNTED, _TEXT("Unmounted"));
		this->SetDlgItemText(IDC_MOUNT_UNMOUNT, _TEXT("Mount"));
	}
	else{
		this->SetDlgItemText(IDC_MOUNTED, _TEXT("???????"));
		this->SetDlgItemText(IDC_MOUNT_UNMOUNT, _TEXT("Unmount"));
	}

	m_bMounted = b;
}

int CCodaStartDlg::GetMounted ()
{
	return m_bMounted;
}

void CCodaStartDlg::OnInitBtn() 
{
	SetInit((m_pInitBtn->GetCheck() == BST_CHECKED) ? TRUE : FALSE);
}

void CCodaStartDlg::OnMountUnmount() 
{
	
	HANDLE hdl;

	char mountstring[] = "N\\\\CODA\\CLUSTER";
    int res, b=-1;
	unsigned long dummy;


	hdl = CreateFile("\\\\.\\CODADEV", 0, 0, NULL, OPEN_EXISTING, FILE_FLAG_DELETE_ON_CLOSE, NULL);
	if (hdl == INVALID_HANDLE_VALUE) {
		AfxMessageBox(IDP_CREATEFILEFAILED);
		return;
	}


	if (GetMounted()==0){
		res = DeviceIoControl(hdl, 2, mountstring, strlen(mountstring), NULL, 0, &dummy, NULL);
		if (!res) 
			AfxMessageBox(IDP_MOUNTFAILED);
		else
			SetMounted(1);
	} 
	else {
		int udpfd;
		int res;
		struct sockaddr_in addr;
		union outputArgs out;

		udpfd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
		if (udpfd == -1) {
			AfxMessageBox(IDP_SOCKETFAILED);
			goto end;
		}

		addr.sin_family = AF_INET;
		addr.sin_addr.s_addr = INADDR_ANY;
		addr.sin_port = 0;
		if (bind(udpfd, (struct sockaddr *) &addr, sizeof(addr)) == -1) {
			AfxMessageBox(IDP_BINDFAILED);
			goto end;
		}

		res = DeviceIoControl(hdl, 8, "N:", 2, NULL, 0, &dummy, NULL);
		if (!res) {
			AfxMessageBox(IDP_UNMOUNTFAILED);
			goto end;
		}
    
		out.oh.opcode = 99;
		addr.sin_addr.s_addr = htonl (0x7f000001);
		addr.sin_port = htons(8001); 
		res = sendto(udpfd, (char *) &out, sizeof(out), 0,
	       (struct sockaddr *) &addr, sizeof(addr));
		if (res == -1){
			AfxMessageBox(IDP_SENDTOFAILED);
			goto end;
		}

		b=0;
end:	SetMounted(b);	
	}

	CloseHandle(hdl);

}

void CCodaStartDlg::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int sel;

	sel = m_pTab->GetCurSel();

	switch (sel){
		case 0:		
			m_pCodaconMsgList->ShowWindow(SW_HIDE);			
			m_pCodaMsgList->ShowWindow(SW_SHOW);			
			break;
		case 1:		
			m_pCodaconMsgList->Connect();				
			m_pCodaconMsgList->ShowWindow(SW_SHOW);			
			m_pCodaMsgList->ShowWindow(SW_HIDE);			
			break;
		default:	break;
	}

	*pResult = 0;
}

void CCodaStartDlg::OnMoreless() 
{
	// TODO: Add your control notification handler code here
	WINDOWPLACEMENT lpwndpl; 
	if (m_bExtension){
		this->SetDlgItemText(IDC_MORELESS, _TEXT(">>>"));
		GetWindowPlacement(&lpwndpl);
		lpwndpl.rcNormalPosition.bottom -= 285;
		SetWindowPlacement(&lpwndpl);
		m_pResetBtn->EnableWindow(FALSE);
	}
	else {
		this->SetDlgItemText(IDC_MORELESS, _TEXT("<<<"));
		GetWindowPlacement(&lpwndpl);
		lpwndpl.rcNormalPosition.bottom += 285;
		SetWindowPlacement(&lpwndpl);
		m_pResetBtn->EnableWindow(TRUE);
	}

	m_bExtension = !m_bExtension;
}

void CCodaStartDlg::OnConf() 
{
	// TODO: Add your control notification handler code here
	CConfDlg dlgConf;
	dlgConf.SetEdit(_TEXT(m_ccommandline));
	if (dlgConf.DoModal()==IDOK){
		dlgConf.GetEdit(m_ccommandline, 200);
//		AfxMessageBox(_TEXT(m_ccommandline));
	}
}
