
#include "stdafx.h"
#include "CodaLSock.h"
#include "CodaStart.h"
#include "CodaStartDlg.h"


#define EDOM		1
#define ERANGE		2
#define E2BIG		3
#define EACCES		4
#define EAGAIN		5
#define EBADF		6
#define EBUSY		7
#define ECHILD		8
#define EDEADLK		9
#define EEXIST		10
#define EFAULT		11
#define EFBIG		12
#define EINTR		13
#define EINVAL		14
#define EIO		15
#define EISDIR		16
#define EMFILE		17
#define EMLINK		18
#define ENAMETOOLONG	19
#define ENFILE		20
#define ENODEV		21
#define ENOENT		22
#define ENOEXEC		23
#define ENOLCK		24
#define ENOMEM		25
#define ENOSPC		26
#define ENOSYS		27
#define ENOTDIR		28
#define ENOTEMPTY	29
#define ENOTTY		30
#define ENXIO		31
#define EPERM		32
#define EPIPE		33
#define EROFS		34
#define ESPIPE		35
#define ESRCH		36
#define EXDEV		37
#define ENMFILE		38
#define EADDRINUSE        1000 /* XXX */
#define EACCESS           1001
#define EPROTONOSUPPORT   1002
#define EWOULDBLOCK       1003
#define ENOTCONN          1004
#define ETIMEDOUT         1005
#define EOPNOTSUPP        1006
#define EDQUOT            1007
#define EALREADY          1008
#define ENOBUFS           1009
#define ETOOMANYREFS      1010
#define ELOOP             1011
#define ESHUTDOWN         1012
#define ETXTBSY           1013

CCodaStartDlg::m_slOpcode = {
  {CODA_ROOT, "CODA_ROOT"},
  {CODA_SYNC, "CODA_SYNC"},
  {CODA_OPEN, "CODA_OPEN"},
  {CODA_CLOSE, "CODA_CLOSE"},
  {CODA_IOCTL, "CODA_IOCTL"},
  {CODA_GETATTR, "CODA_GETATTR"},
  {CODA_SETATTR, "CODA_SETATTR"},
  {CODA_ACCESS, "CODA_ACCESS"},
  {CODA_LOOKUP, "CODA_LOOKUP"},
  {CODA_CREATE, "CODA_CREATE"},
  {CODA_REMOVE, "CODA_REMOVE"},
  {CODA_LINK, "CODA_LINK"},
  {CODA_RENAME, "CODA_RENAME"},
  {CODA_MKDIR, "CODA_MKDIR"},
  {CODA_RMDIR, "CODA_RMDIR"},
  {CODA_READDIR, "CODA_READDIR"},
  {CODA_SYMLINK, "CODA_SYMLINK"},
  {CODA_READLINK, "CODA_READLINK"},
  {CODA_FSYNC, "CODA_FSYNC"},
  {CODA_INACTIVE, "CODA_INACTIVE"},
  {CODA_VGET, "CODA_VGET"},
  {CODA_SIGNAL, "CODA_SIGNAL"},
  {CODA_REPLACE, "CODA_REPLACE"},
  {CODA_FLUSH, "CODA_FLUSH"},
  {CODA_PURGEUSER, "CODA_PURGEUSER"},
  {CODA_ZAPFILE, "CODA_ZAPFILE"},
  {CODA_ZAPDIR, "CODA_ZAPDIR"},
  {CODA_ZAPVNODE, "CODA_ZAPVNODE"},
  {CODA_PURGEFID, "CODA_PURGEFID"},
  {CODA_RDWR, "CODA_RDWR"},
  {ODY_MOUNT, "ODY_MOUNT"},
  {ODY_LOOKUP, "ODY_LOOKUP"},
  {ODY_EXPAND, "ODY_EXPAND"},
  {99, "<<CLOSE>>"},
  {-99, NULL}
};


CCodaStartDlg::m_slErrno = {
   {EDOM, "EDOM"},
   {ERANGE, "ERANGE"},
   {E2BIG, "E2BIG"},
   {EACCES, "EACCES"},
   {EAGAIN, "EAGAIN"},
   {EBADF, "EBADF"},
   {EBUSY, "EBUSY"},
   {ECHILD, "ECHILD"},
   {EDEADLK, "EDEADLK"},
   {EEXIST, "EEXIST"},
   {EFAULT, "EFAULT"},
   {EFBIG, "EFBIG"},
   {EINTR, "EINTR"},
   {EINVAL, "EINVAL"},
   {EIO, "EIO"},
   {EISDIR, "EISDIR"},
   {EMFILE, "EMFILE"},
   {EMLINK, "EMLINK"},
   {ENAMETOOLONG, "ENAMETOOLONG"},
   {ENFILE, "ENFILE"},
   {ENODEV, "ENODEV"},
   {ENOENT, "ENOENT"},
   {ENOEXEC, "ENOEXEC"},
   {ENOLCK, "ENOLCK"},
   {ENOMEM, "ENOMEM"},
   {ENOSPC, "ENOSPC"},
   {ENOSYS, "ENOSYS"},
   {ENOTDIR, "ENOTDIR"},
   {ENOTEMPTY, "ENOTEMPTY"},
   {ENOTTY, "ENOTTY"},
   {ENXIO, "ENXIO"},
   {EPERM, "EPERM"},
   {EPIPE, "EPIPE"},
   {EROFS, "EROFS"},
   {ESPIPE, "ESPIPE"},
   {ESRCH, "ESRCH"},
   {EXDEV, "EXDEV"},
   {ENMFILE, "ENMFILE"},
   {EADDRINUSE, "EADDRINUSE"},
   {EACCESS, "EACCESS"},
   {EPROTONOSUPPORT, "EPROTONOSUPPORT"},
   {EWOULDBLOCK, "EWOULDBLOCK"},
   {ENOTCONN, "ENOTCONN"},
   {ETIMEDOUT, "ETIMEDOUT"},
   {EOPNOTSUPP, "EOPNOTSUPP"},
   {EDQUOT, "EDQUOT"},
   {EALREADY, "EALREADY"},
   {ENOBUFS, "ENOBUFS"},
   {ETOOMANYREFS, "ETOOMANYREFS"},
   {ELOOP, "ELOOP"},
   {ESHUTDOWN, "ESHUTDOWN"},
   {ETXTBSY, "ETXTBSY"},
   {0, NULL}
};

